;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; DOS "hello" program using NASM and TLINK (.EXE file)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SEGMENT _TEXT PUBLIC CLASS=CODE
SEGMENT _DATA PUBLIC CLASS=DATA
SEGMENT _BSS PUBLIC CLASS=BSS
SEGMENT _BSSEND PUBLIC CLASS=BSSEND

%ifdef TINY
GROUP DGROUP _TEXT _DATA _BSS _BSSEND
%else
GROUP DGROUP _DATA _BSS _BSSEND
%endif

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SEGMENT _TEXT

%ifdef TINY
	resb 100h
%endif

..start:		; NASM syntax to specify entry point

%ifdef TINY		; load segment registers
	mov dx,cs
%else
	mov dx,DGROUP
%endif
	mov ds,dx

	mov si,hello
	call puts

	mov ax,4C00h
	int 21h			; DOS INT 21h AH=4Ch: EXIT

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; name:			puts
; action:		sends text string to stdout
; in:			0-terminated string at SI
; out:			(nothing)
; modifies:		(nothing)
; minimum CPU:		8088
; notes:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

puts:
	push si
	push dx
	push ax
		mov ah,2
		jmp short puts_2
puts_1:
		int 21h		; DOS INT 21h AH=02h: WRITE CHAR TO STDOUT
puts_2:
		mov dl,[si]
		inc si
		or dl,dl
		jne puts_1
	pop ax
	pop dx
	pop si
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; DATA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SEGMENT _DATA

hello:
	db "Hello world!", 13, 10, 0
